Response (Apache Tomcat 9.0.37 API Documentation)

org.apache.catalina.connector

## Class Response

- java.lang.Object
- - org.apache.catalina.connector.Response

- All Implemented Interfaces:
    HttpServletResponse, ServletResponse

      public class Response
      extends Object
      implements HttpServletResponse

  Wrapper object for the Coyote response.
  Author:
    Remy Maucherat, Craig R. McClanahan

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `appCommitted` The application commit flag.
    `protected Response` | `coyoteResponse` Coyote response.
    `protected ResponseFacade` | `facade` The facade associated with this response.
    `protected SimpleDateFormat` | `format` Deprecated. Unused. This will be removed in Tomcat 10
    `protected boolean` | `included` The included flag.
    `protected OutputBuffer` | `outputBuffer` The associated output buffer.
    `protected CoyoteOutputStream` | `outputStream` The associated output stream.
    `protected CharChunk` | `redirectURLCC` Recyclable buffer to hold the redirect URL.
    `protected Request` | `request` The request with which this response is associated.
    `protected static StringManager` | `sm`
    `protected UEncoder` | `urlEncoder` URL encoder.
    `protected boolean` | `usingOutputStream` Using output stream flag.
    `protected boolean` | `usingWriter` Using writer flag.
    `protected CoyoteWriter` | `writer` The associated writer.

    - ### Fields inherited from interface javax.servlet.http.HttpServletResponse

      `SC_ACCEPTED, SC_BAD_GATEWAY, SC_BAD_REQUEST, SC_CONFLICT, SC_CONTINUE, SC_CREATED, SC_EXPECTATION_FAILED, SC_FORBIDDEN, SC_FOUND, SC_GATEWAY_TIMEOUT, SC_GONE, SC_HTTP_VERSION_NOT_SUPPORTED, SC_INTERNAL_SERVER_ERROR, SC_LENGTH_REQUIRED, SC_METHOD_NOT_ALLOWED, SC_MOVED_PERMANENTLY, SC_MOVED_TEMPORARILY, SC_MULTIPLE_CHOICES, SC_NO_CONTENT, SC_NON_AUTHORITATIVE_INFORMATION, SC_NOT_ACCEPTABLE, SC_NOT_FOUND, SC_NOT_IMPLEMENTED, SC_NOT_MODIFIED, SC_OK, SC_PARTIAL_CONTENT, SC_PAYMENT_REQUIRED, SC_PRECONDITION_FAILED, SC_PROXY_AUTHENTICATION_REQUIRED, SC_REQUEST_ENTITY_TOO_LARGE, SC_REQUEST_TIMEOUT, SC_REQUEST_URI_TOO_LONG, SC_REQUESTED_RANGE_NOT_SATISFIABLE, SC_RESET_CONTENT, SC_SEE_OTHER, SC_SERVICE_UNAVAILABLE, SC_SWITCHING_PROTOCOLS, SC_TEMPORARY_REDIRECT, SC_UNAUTHORIZED, SC_UNSUPPORTED_MEDIA_TYPE, SC_USE_PROXY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Response()`
    `Response(int outputBufferSize)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addCookie(Cookie cookie)` Add the specified Cookie to those that will be included with this Response.
    `void` | `addDateHeader(String name, long value)` Add the specified date header to the specified value.
    `void` | `addHeader(String name, String value)` Add the specified header to the specified value.
    `void` | `addIntHeader(String name, int value)` Add the specified integer header to the specified value.
    `void` | `addSessionCookieInternal(Cookie cookie)` Special method for adding a session cookie as we should be overriding any previous.
    `boolean` | `containsHeader(String name)` Has the specified header been set already in this response?
    `String` | `encodeRedirectUrl(String url)` Deprecated. As of Version 2.1 of the Java Servlet API, use `encodeRedirectURL()` instead.
    `String` | `encodeRedirectURL(String url)` Encode the session identifier associated with this response into the specified redirect URL, if necessary.
    `String` | `encodeUrl(String url)` Deprecated. As of Version 2.1 of the Java Servlet API, use `encodeURL()` instead.
    `String` | `encodeURL(String url)` Encode the session identifier associated with this response into the specified URL, if necessary.
    `void` | `finishResponse()` Perform whatever actions are required to flush and close the output stream or writer, in a single operation.
    `void` | `flushBuffer()` Flush the buffer and commit this response.
    `String` | `generateCookieString(Cookie cookie)`
    `int` | `getBufferSize()` Returns the actual buffer size used for the response.
    `long` | `getBytesWritten(boolean flush)`
    `String` | `getCharacterEncoding()` Returns the name of the character encoding (MIME charset) used for the body sent in this response.
    `int` | `getContentLength()`
    `String` | `getContentType()` Returns the content type used for the MIME body sent in this response.
    `long` | `getContentWritten()`
    `Context` | `getContext()`
    `List<Cookie>` | `getCookies()`
    `Response` | `getCoyoteResponse()`
    `String` | `getHeader(String name)` Return the value for the specified header, or `null` if this header has not been set.
    `Collection<String>` | `getHeaderNames()` Get the header names set for this HTTP response.
    `Collection<String>` | `getHeaders(String name)` Return a Collection of all the header values associated with the specified header name.
    `Locale` | `getLocale()` Returns the locale specified for this response using the `ServletResponse.setLocale(java.util.Locale)` method.
    `String` | `getMessage()`
    `ServletOutputStream` | `getOutputStream()` Returns a `ServletOutputStream` suitable for writing binary data in the response.
    `PrintWriter` | `getReporter()` Return a PrintWriter that can be used to render error messages, regardless of whether a stream or writer has already been acquired.
    `Request` | `getRequest()`
    `HttpServletResponse` | `getResponse()`
    `int` | `getStatus()` Get the HTTP status code for this Response.
    `Supplier<Map<String,String>>` | `getTrailerFields()` Obtain the supplier of the trailer headers.
    `PrintWriter` | `getWriter()` Returns a `PrintWriter` object that can send character text to the client.
    `boolean` | `isAppCommitted()` Application commit flag accessor.
    `boolean` | `isClosed()` Closed flag accessor.
    `boolean` | `isCommitted()` Has the output of this response already been committed?
    `protected boolean` | `isEncodeable(String location)` Return `true` if the specified URL should be encoded with a session identifier.
    `boolean` | `isError()` Error flag accessor.
    `boolean` | `isErrorReportRequired()`
    `boolean` | `isSuspended()` Suspended flag accessor.
    `void` | `recycle()` Release all object references, and initialize instance variables, in preparation for reuse of this object.
    `void` | `reset()` Clear any content written to the buffer.
    `void` | `resetBuffer()` Reset the data buffer but not any status or header information.
    `void` | `resetBuffer(boolean resetWriterStreamFlags)` Reset the data buffer and the using Writer/Stream flags but not any status or header information.
    `void` | `sendAcknowledgement()` Send an acknowledgement of a request.
    `void` | `sendError(int status)` Send an error response with the specified status and a default message.
    `void` | `sendError(int status, String message)` Send an error response with the specified status and message.
    `void` | `sendRedirect(String location)` Send a temporary redirect to the specified redirect location URL.
    `void` | `sendRedirect(String location, int status)` Internal method that allows a redirect to be sent with a status other than `HttpServletResponse.SC_FOUND` (302).
    `void` | `setAppCommitted(boolean appCommitted)` Set the application commit flag.
    `void` | `setBufferSize(int size)` Set the buffer size to be used for this Response.
    `void` | `setCharacterEncoding(String charset)` Overrides the name of the character encoding used in the body of the request.
    `void` | `setContentLength(int length)` Set the content length (in bytes) for this Response.
    `void` | `setContentLengthLong(long length)` Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
    `void` | `setContentType(String type)` Set the content type for this Response.
    `void` | `setCoyoteResponse(Response coyoteResponse)` Set the Coyote response.
    `void` | `setDateHeader(String name, long value)` Set the specified date header to the specified value.
    `boolean` | `setError()` Set the error flag.
    `boolean` | `setErrorReported()`
    `void` | `setHeader(String name, String value)` Set the specified header to the specified value.
    `void` | `setIntHeader(String name, int value)` Set the specified integer header to the specified value.
    `void` | `setLocale(Locale locale)` Set the Locale that is appropriate for this response, including setting the appropriate character encoding.
    `void` | `setRequest(Request request)` Set the Request with which this Response is associated.
    `void` | `setResponse(HttpServletResponse applicationResponse)` Set a wrapped HttpServletResponse to pass to the application.
    `void` | `setStatus(int status)` Set the HTTP status to be returned with this response.
    `void` | `setStatus(int status, String message)` Deprecated. As of Version 2.1 of the Java Servlet API, this method has been deprecated due to the ambiguous meaning of the message parameter.
    `void` | `setSuspended(boolean suspended)` Set the suspended flag.
    `void` | `setTrailerFields(Supplier<Map<String,String>> supplier)` Configure the supplier of the trailer headers.
    `protected String` | `toAbsolute(String location)` Convert (if necessary) and return the absolute URL that represents the resource referenced by this possibly relative URL.
    `protected String` | `toEncoded(String url, String sessionId)` Return the specified URL with the specified session identifier suitably encoded.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sm

          protected static final StringManager sm

    - #### format

          @Deprecated
          protected SimpleDateFormat format

      Deprecated. Unused. This will be removed in Tomcat 10
      The date format we will use for creating date headers.

    - #### coyoteResponse

          protected Response coyoteResponse

      Coyote response.

    - #### outputBuffer

          protected final OutputBuffer outputBuffer

      The associated output buffer.

    - #### outputStream

          protected CoyoteOutputStream outputStream

      The associated output stream.

    - #### writer

          protected CoyoteWriter writer

      The associated writer.

    - #### appCommitted

          protected boolean appCommitted

      The application commit flag.

    - #### included

          protected boolean included

      The included flag.

    - #### usingOutputStream

          protected boolean usingOutputStream

      Using output stream flag.

    - #### usingWriter

          protected boolean usingWriter

      Using writer flag.

    - #### urlEncoder

          protected final UEncoder urlEncoder

      URL encoder.

    - #### redirectURLCC

          protected final CharChunk redirectURLCC

      Recyclable buffer to hold the redirect URL.

    - #### request

          protected Request request

      The request with which this response is associated.

    - #### facade

          protected ResponseFacade facade

      The facade associated with this response.

  - ### Constructor Detail

    - #### Response

          public Response()

    - #### Response

          public Response(int outputBufferSize)

  - ### Method Detail

    - #### setCoyoteResponse

          public void setCoyoteResponse(Response coyoteResponse)

      Set the Coyote response.
      Parameters:
        `coyoteResponse` - The Coyote response

    - #### getCoyoteResponse

          public Response getCoyoteResponse()

      Returns:
        the Coyote response.

    - #### getContext

          public Context getContext()

      Returns:
        the Context within which this Request is being processed.

    - #### recycle

          public void recycle()

      Release all object references, and initialize instance variables, in preparation for reuse of this object.

    - #### getCookies

          public List<Cookie> getCookies()

    - #### getContentWritten

          public long getContentWritten()

      Returns:
        the number of bytes the application has actually written to the output stream. This excludes chunking, compression, etc. as well as headers.

    - #### getBytesWritten

          public long getBytesWritten(boolean flush)

      Parameters:
        `flush` - if `true` will perform a buffer flush first
      Returns:
        the number of bytes the actually written to the socket. This includes chunking, compression, etc. but excludes headers.

    - #### setAppCommitted

          public void setAppCommitted(boolean appCommitted)

      Set the application commit flag.
      Parameters:
        `appCommitted` - The new application committed flag value

    - #### isAppCommitted

          public boolean isAppCommitted()

      Application commit flag accessor.
      Returns:
        `true` if the application has committed the response

    - #### getRequest

          public Request getRequest()

      Returns:
        the Request with which this Response is associated.

    - #### setRequest

          public void setRequest(Request request)

      Set the Request with which this Response is associated.
      Parameters:
        `request` - The new associated request

    - #### getResponse

          public HttpServletResponse getResponse()

      Returns:
        the `ServletResponse` for which this object is the facade.

    - #### setResponse

          public void setResponse(HttpServletResponse applicationResponse)

      Set a wrapped HttpServletResponse to pass to the application. Components wishing to wrap the response should obtain the response via `getResponse()`, wrap it and then call this method with the wrapped response.
      Parameters:
        `applicationResponse` - The wrapped response to pass to the application

    - #### setSuspended

          public void setSuspended(boolean suspended)

      Set the suspended flag.
      Parameters:
        `suspended` - The new suspended flag value

    - #### isSuspended

          public boolean isSuspended()

      Suspended flag accessor.
      Returns:
        `true` if the response is suspended

    - #### isClosed

          public boolean isClosed()

      Closed flag accessor.
      Returns:
        `true` if the response has been closed

    - #### setError

          public boolean setError()

      Set the error flag.
      Returns:
        `false` if the error flag was already set

    - #### isError

          public boolean isError()

      Error flag accessor.
      Returns:
        `true` if the response has encountered an error

    - #### isErrorReportRequired

          public boolean isErrorReportRequired()

    - #### setErrorReported

          public boolean setErrorReported()

    - #### finishResponse

          public void finishResponse()
                              throws IOException

      Perform whatever actions are required to flush and close the output stream or writer, in a single operation.
      Throws:
        `IOException` - if an input/output error occurs

    - #### getContentLength

          public int getContentLength()

      Returns:
        the content length that was set or calculated for this Response.

    - #### getContentType

          public String getContentType()

      Description copied from interface: `javax.servlet.ServletResponse`
      Returns the content type used for the MIME body sent in this response. The content type proper must have been specified using `ServletResponse.setContentType(java.lang.String)` before the response is committed. If no content type has been specified, this method returns null. If a content type has been specified and a character encoding has been explicitly or implicitly specified as described in `ServletResponse.getCharacterEncoding()`, the charset parameter is included in the string returned. If no character encoding has been specified, the charset parameter is omitted.
      Specified by:
        `getContentType` in interface `ServletResponse`
      Returns:
        the content type that was set or calculated for this response, or `null` if no content type was set.

    - #### getReporter

          public PrintWriter getReporter()
                                  throws IOException

      Return a PrintWriter that can be used to render error messages, regardless of whether a stream or writer has already been acquired.
      Returns:
        Writer which can be used for error reports. If the response is not an error report returned using sendError or triggered by an unexpected exception thrown during the servlet processing (and only in that case), null will be returned if the response stream has already been used.
      Throws:
        `IOException` - if an input/output error occurs

    - #### flushBuffer

          public void flushBuffer()
                           throws IOException

      Flush the buffer and commit this response.
      Specified by:
        `flushBuffer` in interface `ServletResponse`
      Throws:
        `IOException` - if an input/output error occurs
      See Also:
        `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

    - #### getBufferSize

          public int getBufferSize()

      Description copied from interface: `javax.servlet.ServletResponse`
      Returns the actual buffer size used for the response. If no buffering is used, this method returns 0.
      Specified by:
        `getBufferSize` in interface `ServletResponse`
      Returns:
        the actual buffer size used for this Response.
      See Also:
        `ServletResponse.setBufferSize(int)`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

    - #### getCharacterEncoding

          public String getCharacterEncoding()

      Description copied from interface: `javax.servlet.ServletResponse`
      Returns the name of the character encoding (MIME charset) used for the body sent in this response. The charset for the MIME body response can be specified explicitly or implicitly. The priority order for specifying the response body is:
      1. explicitly per request using `ServletResponse.setCharacterEncoding(java.lang.String)` and `ServletResponse.setContentType(java.lang.String)`
      2. implicitly per request using `ServletResponse.setLocale(java.util.Locale)`
      3. per web application via the deployment descriptor or `ServletContext.setRequestCharacterEncoding(String)`
      4. container default via vendor specific configuration
      5. ISO-8859-1
      Calls made to `ServletResponse.setCharacterEncoding(java.lang.String)`, `ServletResponse.setContentType(java.lang.String)` or `ServletResponse.setLocale(java.util.Locale)` after `getWriter` has been called or after the response has been committed have no effect on the character encoding. If no character encoding has been specified, `ISO-8859-1` is returned.

      See RFC 2047 (http://www.ietf.org/rfc/rfc2047.txt) for more information about character encoding and MIME.

      Specified by:
        `getCharacterEncoding` in interface `ServletResponse`
      Returns:
        the character encoding used for this Response.

    - #### getOutputStream

          public ServletOutputStream getOutputStream()
                                              throws IOException

      Description copied from interface: `javax.servlet.ServletResponse`
      Returns a `ServletOutputStream` suitable for writing binary data in the response. The servlet container does not encode the binary data.

      Calling flush() on the ServletOutputStream commits the response. Either this method or `ServletResponse.getWriter()` may be called to write the body, not both.

      Specified by:
        `getOutputStream` in interface `ServletResponse`
      Returns:
        the servlet output stream associated with this Response.
      Throws:
        `IllegalStateException` - if `getWriter` has already been called for this response
        `IOException` - if an input/output error occurs
      See Also:
        `ServletResponse.getWriter()`

    - #### getLocale

          public Locale getLocale()

      Description copied from interface: `javax.servlet.ServletResponse`
      Returns the locale specified for this response using the `ServletResponse.setLocale(java.util.Locale)` method. Calls made to `setLocale` after the response is committed have no effect.
      Specified by:
        `getLocale` in interface `ServletResponse`
      Returns:
        the Locale assigned to this response.
      See Also:
        `ServletResponse.setLocale(java.util.Locale)`

    - #### getWriter

          public PrintWriter getWriter()
                                throws IOException

      Description copied from interface: `javax.servlet.ServletResponse`
      Returns a `PrintWriter` object that can send character text to the client. The `PrintWriter` uses the character encoding returned by `ServletResponse.getCharacterEncoding()`. If the response's character encoding has not been specified as described in `getCharacterEncoding` (i.e., the method just returns the default value `ISO-8859-1`), `getWriter` updates it to `ISO-8859-1`.

      Calling flush() on the `PrintWriter` commits the response.

      Either this method or `ServletResponse.getOutputStream()` may be called to write the body, not both.

      Specified by:
        `getWriter` in interface `ServletResponse`
      Returns:
        the writer associated with this Response.
      Throws:
        `IllegalStateException` - if `getOutputStream` has already been called for this response
        `IOException` - if an input/output error occurs
      See Also:
        `ServletResponse.getOutputStream()`, `ServletResponse.setCharacterEncoding(java.lang.String)`

    - #### isCommitted

          public boolean isCommitted()

      Has the output of this response already been committed?
      Specified by:
        `isCommitted` in interface `ServletResponse`
      Returns:
        `true` if the response has been committed
      See Also:
        `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.reset()`

    - #### reset

          public void reset()

      Clear any content written to the buffer.
      Specified by:
        `reset` in interface `ServletResponse`
      Throws:
        `IllegalStateException` - if this response has already been committed
      See Also:
        `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`

    - #### resetBuffer

          public void resetBuffer()

      Reset the data buffer but not any status or header information.
      Specified by:
        `resetBuffer` in interface `ServletResponse`
      Throws:
        `IllegalStateException` - if the response has already been committed
      See Also:
        `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

    - #### resetBuffer

          public void resetBuffer(boolean resetWriterStreamFlags)

      Reset the data buffer and the using Writer/Stream flags but not any status or header information.
      Parameters:
        `resetWriterStreamFlags` - `true` if the internal `usingWriter`, `usingOutputStream`, `isCharacterEncodingSet` flags should also be reset
      Throws:
        `IllegalStateException` - if the response has already been committed

    - #### setBufferSize

          public void setBufferSize(int size)

      Set the buffer size to be used for this Response.
      Specified by:
        `setBufferSize` in interface `ServletResponse`
      Parameters:
        `size` - The new buffer size
      Throws:
        `IllegalStateException` - if this method is called after output has been committed for this response
      See Also:
        `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

    - #### setContentLength

          public void setContentLength(int length)

      Set the content length (in bytes) for this Response.
      Specified by:
        `setContentLength` in interface `ServletResponse`
      Parameters:
        `length` - The new content length

    - #### setContentLengthLong

          public void setContentLengthLong(long length)

      Description copied from interface: `javax.servlet.ServletResponse`
      Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
      Specified by:
        `setContentLengthLong` in interface `ServletResponse`
      Parameters:
        `length` - an integer specifying the length of the content being returned to the client; sets the Content-Length header

    - #### setContentType

          public void setContentType(String type)

      Set the content type for this Response.
      Specified by:
        `setContentType` in interface `ServletResponse`
      Parameters:
        `type` - The new content type
      See Also:
        `ServletResponse.setLocale(java.util.Locale)`, `ServletResponse.setCharacterEncoding(java.lang.String)`, `ServletResponse.getOutputStream()`, `ServletResponse.getWriter()`

    - #### setCharacterEncoding

          public void setCharacterEncoding(String charset)

      Overrides the name of the character encoding used in the body of the request. This method must be called prior to reading request parameters or reading input using getReader().
      Specified by:
        `setCharacterEncoding` in interface `ServletResponse`
      Parameters:
        `charset` - String containing the name of the character encoding.
      See Also:
        `#setLocale`

    - #### setLocale

          public void setLocale(Locale locale)

      Set the Locale that is appropriate for this response, including setting the appropriate character encoding.
      Specified by:
        `setLocale` in interface `ServletResponse`
      Parameters:
        `locale` - The new locale
      See Also:
        `ServletResponse.getLocale()`, `ServletResponse.setContentType(java.lang.String)`, `ServletResponse.setCharacterEncoding(java.lang.String)`

    - #### getHeader

          public String getHeader(String name)

      Description copied from interface: `javax.servlet.http.HttpServletResponse`
      Return the value for the specified header, or `null` if this header has not been set. If more than one value was added for this name, only the first is returned; use `HttpServletResponse.getHeaders(String)` to retrieve all of them.
      Specified by:
        `getHeader` in interface `HttpServletResponse`
      Parameters:
        `name` - Header name to look up
      Returns:
        The first value for the specified header. This is the raw value so if multiple values are specified in the first header then they will be returned as a single header value .

    - #### getHeaderNames

          public Collection<String> getHeaderNames()

      Description copied from interface: `javax.servlet.http.HttpServletResponse`
      Get the header names set for this HTTP response.
      Specified by:
        `getHeaderNames` in interface `HttpServletResponse`
      Returns:
        The header names set for this HTTP response.

    - #### getHeaders

          public Collection<String> getHeaders(String name)

      Description copied from interface: `javax.servlet.http.HttpServletResponse`
      Return a Collection of all the header values associated with the specified header name.
      Specified by:
        `getHeaders` in interface `HttpServletResponse`
      Parameters:
        `name` - Header name to look up
      Returns:
        The values for the specified header. These are the raw values so if multiple values are specified in a single header that will be returned as a single header value.

    - #### getMessage

          public String getMessage()

      Returns:
        the error message that was set with `sendError()` for this Response.

    - #### getStatus

          public int getStatus()

      Description copied from interface: `javax.servlet.http.HttpServletResponse`
      Get the HTTP status code for this Response.
      Specified by:
        `getStatus` in interface `HttpServletResponse`
      Returns:
        The HTTP status code for this Response

    - #### addCookie

          public void addCookie(Cookie cookie)

      Add the specified Cookie to those that will be included with this Response.
      Specified by:
        `addCookie` in interface `HttpServletResponse`
      Parameters:
        `cookie` - Cookie to be added

    - #### addSessionCookieInternal

          public void addSessionCookieInternal(Cookie cookie)

      Special method for adding a session cookie as we should be overriding any previous.
      Parameters:
        `cookie` - The new session cookie to add the response

    - #### generateCookieString

          public String generateCookieString(Cookie cookie)

    - #### addDateHeader

          public void addDateHeader(String name,
                                    long value)

      Add the specified date header to the specified value.
      Specified by:
        `addDateHeader` in interface `HttpServletResponse`
      Parameters:
        `name` - Name of the header to set
        `value` - Date value to be set
      See Also:
        `HttpServletResponse.setDateHeader(java.lang.String, long)`

    - #### addHeader

          public void addHeader(String name,
                                String value)

      Add the specified header to the specified value.
      Specified by:
        `addHeader` in interface `HttpServletResponse`
      Parameters:
        `name` - Name of the header to set
        `value` - Value to be set
      See Also:
        `HttpServletResponse.setHeader(java.lang.String, java.lang.String)`

    - #### addIntHeader

          public void addIntHeader(String name,
                                   int value)

      Add the specified integer header to the specified value.
      Specified by:
        `addIntHeader` in interface `HttpServletResponse`
      Parameters:
        `name` - Name of the header to set
        `value` - Integer value to be set
      See Also:
        `HttpServletResponse.setIntHeader(java.lang.String, int)`

    - #### containsHeader

          public boolean containsHeader(String name)

      Has the specified header been set already in this response?
      Specified by:
        `containsHeader` in interface `HttpServletResponse`
      Parameters:
        `name` - Name of the header to check
      Returns:
        `true` if the header has been set

    - #### setTrailerFields

          public void setTrailerFields(Supplier<Map<String,String>> supplier)

      Description copied from interface: `javax.servlet.http.HttpServletResponse`
      Configure the supplier of the trailer headers. The supplier will be called in the scope of the thread that completes the response.
      Trailers that don't meet the requirements of RFC 7230, section 4.1.2 will be ignored.
      The default implementation is a NO-OP.
      Specified by:
        `setTrailerFields` in interface `HttpServletResponse`
      Parameters:
        `supplier` - The supplier for the trailer headers

    - #### getTrailerFields

          public Supplier<Map<String,String>> getTrailerFields()

      Description copied from interface: `javax.servlet.http.HttpServletResponse`
      Obtain the supplier of the trailer headers.
      The default implementation returns null.
      Specified by:
        `getTrailerFields` in interface `HttpServletResponse`
      Returns:
        The supplier for the trailer headers

    - #### encodeRedirectURL

          public String encodeRedirectURL(String url)

      Encode the session identifier associated with this response into the specified redirect URL, if necessary.
      Specified by:
        `encodeRedirectURL` in interface `HttpServletResponse`
      Parameters:
        `url` - URL to be encoded
      Returns:
        `true` if the URL was encoded
      See Also:
        `HttpServletResponse.sendRedirect(java.lang.String)`, `HttpServletResponse.encodeUrl(java.lang.String)`

    - #### encodeRedirectUrl

          @Deprecated
          public String encodeRedirectUrl(String url)

      Deprecated. As of Version 2.1 of the Java Servlet API, use `encodeRedirectURL()` instead.
      Encode the session identifier associated with this response into the specified redirect URL, if necessary.
      Specified by:
        `encodeRedirectUrl` in interface `HttpServletResponse`
      Parameters:
        `url` - URL to be encoded
      Returns:
        `true` if the URL was encoded

    - #### encodeURL

          public String encodeURL(String url)

      Encode the session identifier associated with this response into the specified URL, if necessary.
      Specified by:
        `encodeURL` in interface `HttpServletResponse`
      Parameters:
        `url` - URL to be encoded
      Returns:
        `true` if the URL was encoded

    - #### encodeUrl

          @Deprecated
          public String encodeUrl(String url)

      Deprecated. As of Version 2.1 of the Java Servlet API, use `encodeURL()` instead.
      Encode the session identifier associated with this response into the specified URL, if necessary.
      Specified by:
        `encodeUrl` in interface `HttpServletResponse`
      Parameters:
        `url` - URL to be encoded
      Returns:
        `true` if the URL was encoded

    - #### sendAcknowledgement

          public void sendAcknowledgement()
                                   throws IOException

      Send an acknowledgement of a request.
      Throws:
        `IOException` - if an input/output error occurs

    - #### sendError

          public void sendError(int status)
                         throws IOException

      Send an error response with the specified status and a default message.
      Specified by:
        `sendError` in interface `HttpServletResponse`
      Parameters:
        `status` - HTTP status code to send
      Throws:
        `IllegalStateException` - if this response has already been committed
        `IOException` - if an input/output error occurs

    - #### sendError

          public void sendError(int status,
                                String message)
                         throws IOException

      Send an error response with the specified status and message.
      Specified by:
        `sendError` in interface `HttpServletResponse`
      Parameters:
        `status` - HTTP status code to send
        `message` - Corresponding message to send
      Throws:
        `IllegalStateException` - if this response has already been committed
        `IOException` - if an input/output error occurs

    - #### sendRedirect

          public void sendRedirect(String location)
                            throws IOException

      Send a temporary redirect to the specified redirect location URL.
      Specified by:
        `sendRedirect` in interface `HttpServletResponse`
      Parameters:
        `location` - Location URL to redirect to
      Throws:
        `IllegalStateException` - if this response has already been committed
        `IOException` - if an input/output error occurs

    - #### sendRedirect

          public void sendRedirect(String location,
                                   int status)
                            throws IOException

      Internal method that allows a redirect to be sent with a status other than `HttpServletResponse.SC_FOUND` (302). No attempt is made to validate the status code.
      Parameters:
        `location` - Location URL to redirect to
        `status` - HTTP status code that will be sent
      Throws:
        `IOException` - an IO exception occurred

    - #### setDateHeader

          public void setDateHeader(String name,
                                    long value)

      Set the specified date header to the specified value.
      Specified by:
        `setDateHeader` in interface `HttpServletResponse`
      Parameters:
        `name` - Name of the header to set
        `value` - Date value to be set
      See Also:
        `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addDateHeader(java.lang.String, long)`

    - #### setHeader

          public void setHeader(String name,
                                String value)

      Set the specified header to the specified value.
      Specified by:
        `setHeader` in interface `HttpServletResponse`
      Parameters:
        `name` - Name of the header to set
        `value` - Value to be set
      See Also:
        `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addHeader(java.lang.String, java.lang.String)`

    - #### setIntHeader

          public void setIntHeader(String name,
                                   int value)

      Set the specified integer header to the specified value.
      Specified by:
        `setIntHeader` in interface `HttpServletResponse`
      Parameters:
        `name` - Name of the header to set
        `value` - Integer value to be set
      See Also:
        `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addIntHeader(java.lang.String, int)`

    - #### setStatus

          public void setStatus(int status)

      Set the HTTP status to be returned with this response.
      Specified by:
        `setStatus` in interface `HttpServletResponse`
      Parameters:
        `status` - The new HTTP status
      See Also:
        `HttpServletResponse.sendError(int, java.lang.String)`

    - #### setStatus

          @Deprecated
          public void setStatus(int status,
                                             String message)

      Deprecated. As of Version 2.1 of the Java Servlet API, this method has been deprecated due to the ambiguous meaning of the message parameter.
      Set the HTTP status and message to be returned with this response.
      Specified by:
        `setStatus` in interface `HttpServletResponse`
      Parameters:
        `status` - The new HTTP status
        `message` - The associated text message

    - #### isEncodeable

          protected boolean isEncodeable(String location)

      Return `true` if the specified URL should be encoded with a session identifier. This will be true if all of the following conditions are met:
      - The request we are responding to asked for a valid session
      - The requested session ID was not received via a cookie
      - The specified URL points back to somewhere within the web application that is responding to this request
      Parameters:
        `location` - Absolute URL to be validated
      Returns:
        `true` if the URL should be encoded

    - #### toAbsolute

          protected String toAbsolute(String location)

      Convert (if necessary) and return the absolute URL that represents the resource referenced by this possibly relative URL. If this URL is already absolute, return it unchanged.
      Parameters:
        `location` - URL to be (possibly) converted and then returned
      Returns:
        the encoded URL
      Throws:
        `IllegalArgumentException` - if a MalformedURLException is thrown when converting the relative URL to an absolute one

    - #### toEncoded

          protected String toEncoded(String url,
                                     String sessionId)

      Return the specified URL with the specified session identifier suitably encoded.
      Parameters:
        `url` - URL to be encoded with the session id
        `sessionId` - Session id to be included in the encoded URL
      Returns:
        the encoded URL

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.